import sys

class Person(object):
	"""I define a Person"""
	__class__ = "Person"
	
	def __init__(self, name, age):
		self.name = name
		self.age = age
	
	def intro(self):
		"""Returns an introduction of the person"""
		return "Hello, my name is %s and I'm %s." % (self.name, self.age)


def printAttr(Class, attrName):
	"""Prints the attribute attrName from the class Class if it exists"""
	if hasattr( Class, attrName ):
		print( "\n", getattr( Class, attrName ) )
	else:
		print( "\n", Class.name, "does not contain the attribute", attrName )

# def interrogate(item):
# 	"""prints usefull information about an item"""
# 	print("")
# 	if hasattr( item, '__name__' ):
# 		print( "Name:	", item.__name__ )
# 	if hasattr( item, '__class__' ):
# 		print( "Class:	", item.__class__ )
# 	print( "ID:	", id(item) )
# 	print("TYPE:	", type(item))
# 	print( "VALUE:	", repr(item) )
# 	# if callable( item ):
# 	# 		str = "YES"
# 	# 	else:
# 	# 		str = "NO"
# 	# 	print( "Callable:	", str )
# 	if hasattr(item, '__doc__'):
# 		doc = getattr(item, '__doc__')
# 	doc = doc.strip() # remove leading/trailing white-space
# 	firstline = doc.split('\n')[0]
# 	print( "DOC:	", firstline )

# make some instanses of the class
bob = Person( "B-Man", 34 )
jane = Person( "Janie", 67 )

# add an extra attribute to one of the instances
jane.sport = "football/soccer/stfu"

# print the introduction - the same
print(bob.intro())
print(jane.intro())

# print description of class Person
# - they differ on the "sport"-attribute
print("bob:",dir( bob ))
print("jane:", dir( jane ))
#print( dir(Person) )
# print( dir.__doc__ )

delattr(jane, "sport")
print("jane (post-delattr): ", dir(jane))
setattr( jane, "sport", "pilates" )
# print("jane (post-delattr): ", dir(jane))
		
# Check in which instance the variable "sport" is
printAttr( bob, "sport" )
printAttr( jane, "sport" )

# interrogate( dir )
# interrogate( jane )
# interrogate( interrogate )